##  for Mageia 9  ##

%define ver 1.5.32
%define rel 1

%define api   1.0
%define major 5
%define libname %mklibname %{name} %{api} %{major}
%define girname %mklibname ibus-gir %{api}

# turn off debuginfo package
%define debug_package %{nil}


Name:    ibus
Summary: A next generation input framework
Version: %{ver}
Release: %{rel}.np9
Group:   System/Internationalization
License: LGPLv2+
URL:     https://github.com/ibus/ibus/wiki

Source0: https://github.com/ibus/ibus/archive/ibus-%{version}.tar.gz
Source1: macros.ibus

BuildRequires: dbus-devel
BuildRequires: python-dbus-devel
BuildRequires: dconf-devel
BuildRequires: gtk+2-devel
BuildRequires: gtk+3-devel
BuildRequires: gtk4-devel
BuildRequires: glib2-devel
BuildRequires: %{_lib}girepository-devel
BuildRequires: iso-codes
BuildRequires: libnotify-devel
BuildRequires: python3-gobject-devel
BuildRequires: libx11-devel
BuildRequires: gettext-devel
BuildRequires: gtk-doc
BuildRequires: vala-devel
BuildRequires: cldr-emoji-annotation >= 37.0_13.0_0_2
BuildRequires: unicode-emoji >= 16.0
BuildRequires: unicode-ucd >= 16.0.0
BuildRequires: json-glib-devel
BuildRequires: wayland-devel
#
BuildRequires: python3-devel
BuildRequires: dbus-glib-devel
BuildRequires: dbus-x11
BuildRequires: desktop-file-utils
BuildRequires: intltool
BuildRequires: libxtst-devel

Requires: %{libname} = %{version}-%{release}
Requires: ibus-ui-gtk3 = %{version}-%{release}
#Requires: ibus-gtk = %%{version}-%%{release}
Requires: ibus-gtk3 = %{version}-%{release}
Requires: ibus-dicts-emoji = %{version}-%{release}
Requires: python3-gobject
Requires: python3-dbus
Requires: python3-pyxdg
Requires: iso-codes
Requires: librsvg
Requires: dconf
#
Requires: python3-notify2
Requires: dbus-x11

%description
IBus is a next generation input framework.

Please re-login or reboot your PC, after installed this package.

%posttrans
glib-compile-schemas %{_datadir}/glib-2.0/schemas &>/dev/null
dconf update

%postun
glib-compile-schemas %{_datadir}/glib-2.0/schemas &>/dev/null
dconf update

# ------------------------------------------------------

%package -n %{libname}
Summary: Shared libraries for %{name}
Group:   System/Internationalization
Requires: gobject-introspection

%description -n %{libname}
IBus shared libraries.

# ------------------------------------------------------

%package -n %girname
Summary: GObject introspection interface library for ibus
Group:   System/Internationalization
Requires: %{libname} = %{version}-%{release}

%description -n %girname
GObject introspection interface library for ibus.

# ------------------------------------------------------

%package devel
Summary: Headers of %{name} for development
Group:   Development/C
Requires: %{libname} = %{version}-%{release}
Requires: %{girname} = %{version}-%{release}

%description devel
IBus development package: static libraries, header files, and the like.

# ------------------------------------------------------

%package gtk
Summary: IBus gtk+2 module
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}

%description gtk
IBus gtk+2 module.

%post gtk
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

%postun gtk
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

# ------------------------------------------------------

%package ui-gtk3
Summary: GTK+ 3.0 UI for IBus
Group:   System/Internationalization
Provides: ibus-ui
BuildRequires: %{_lib}dbusmenu-glib-devel
BuildRequires: %{_lib}dbusmenu-gtk3-devel
Requires: %{name} = %{version}-%{release}
Requires: %{_lib}dbusmenu-gtk3_4
Recommends: %{name}-gtk3 = %{version}-%{release}

%description ui-gtk3
GTK+ 3.0 UI for IBus.

This package contains IBus Panel icon using GtkStatusIcon or AppIndicator in non-GNOME desktop sessions likes XFCE or Plasma, because gnome-shell shows the IBus Icon.
This package depends on libdbusmenu-gtk3 for Wayland desktop sessions.

# ------------------------------------------------------

%package gtk3
Summary: IBus gtk+3 module
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}

%description gtk3
IBus gtk3 module.

%post gtk3
gtk-query-immodules-3.0 --update-cache

%postun gtk3
gtk-query-immodules-3.0 --update-cache

# ------------------------------------------------------

%package gtk4
Summary: IBus gtk4 module
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}

%description gtk4
IBus gtk4 module.

%post gtk4
%{_bindir}/gio-querymodules-%{__isa_bits} %{_libdir}/gtk-4.0/4.0.0/immodules

%postun gtk4
%{_bindir}/gio-querymodules-%{__isa_bits} %{_libdir}/gtk-4.0/4.0.0/immodules

# ------------------------------------------------------

%package dicts-emoji
Summary: IBus emoji dictionaries
Group:   System/Internationalization
BuildArch: noarch

%description dicts-emoji
IBus emoji dictionaries.

# ------------------------------------------------------

%prep
%setup -q

# ------------------------------------------------------

%build
# workaround for build error
rm -f portal/ibus-portal-dbus.*
autoreconf -vfi
#

%configure \
--enable-vala=yes \
--enable-gtk4 \
--enable-gtk-doc \
--with-python=python3 --disable-python2 --disable-python-library \
--disable-dbus-python-check \
--enable-wayland \
--disable-static

%make_build

# ------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT
%make_install

## install rpm macro
mkdir -p $RPM_BUILD_ROOT%{_rpmmacrodir}/
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT%{_rpmmacrodir}/macros.ibus

## install .desktop files
desktop-file-install \
 --vendor="" \
 --add-category="X-MandrivaLinux-System-Configuration" \
 --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/org.freedesktop.IBus.Setup.desktop

##
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d/
mv -f $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/ibus.bash $RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d/

## remove unneeded files
find $RPM_BUILD_ROOT -name '*.la' | xargs rm

%find_lang %{name}10

# ------------------------------------------------------

%files -f %{name}10.lang
%defattr(-,root,root)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_sysconfdir}/bash_completion.d/ibus.bash
%{_sysconfdir}/dconf/db/ibus.d/00-upstream-settings
%{_sysconfdir}/dconf/profile/ibus
%{_sysconfdir}/xdg/Xwayland-session.d/10-ibus-x11
%{_bindir}/*
%{_libexecdir}/ibus-dconf
%{_libexecdir}/ibus-engine-simple
%{_libexecdir}/ibus-x11
%{_libexecdir}/ibus-ui-emojier
%{_libexecdir}/ibus-wayland
%{_libexecdir}/ibus-portal
%{_libexecdir}/ibus-extension-gtk3
%{_userunitdir}/gnome-session.target.wants/org.freedesktop.IBus.session.GNOME.service
%{_userunitdir}/org.freedesktop.IBus.session.*.service
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_datadir}/applications/*.desktop
%{_datadir}/ibus/*
%{_datadir}/GConf/gsettings/ibus.convert
%{_datadir}/glib-2.0/schemas/org.freedesktop.ibus.gschema.xml
%{_datadir}/dbus-1/services/org.freedesktop.IBus.service
%{_datadir}/dbus-1/services/org.freedesktop.portal.IBus.service
%{_datadir}/gettext/its/ibus.*
%{_iconsdir}/*/*/*/ibus*
%{python3_sitearch}/gi/overrides/IBus.*
%{python3_sitearch}/gi/overrides/__pycache__/IBus.*
%exclude %{_datadir}/ibus/component/gtkpanel.xml
%exclude %{_datadir}/ibus/dicts/emoji-*.dict

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libibus-%{api}.so.%{major}
%{_libdir}/libibus-%{api}.so.%{major}.*

%files -n %{girname}
%defattr(-,root,root)
%{_libdir}/girepository-1.0/*.typelib

%files gtk
%defattr(-,root,root)
%{_libdir}/gtk-2.0/*/immodules/*.so

%files ui-gtk3
%defattr(-,root,root)
%{_libexecdir}/ibus-ui-gtk3
%{_datadir}/ibus/component/gtkpanel.xml

%files gtk3
%defattr(-,root,root)
%{_libdir}/gtk-3.0/*/immodules/*.so

%files gtk4
%defattr(-,root,root)
%{_libdir}/gtk-4.0/*/immodules/*.so

%files dicts-emoji
%defattr(-,root,root)
%{_datadir}/ibus/dicts/emoji-*.dict

%files devel
%defattr(-,root,root)
%{_includedir}/ibus-1.0
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_datadir}/gtk-doc/html/ibus/*
%{_datadir}/gir-1.0/*.gir
%{_datadir}/vala/vapi/*.vapi
%{_datadir}/vala/vapi/*.deps
%{_rpmmacrodir}/macros.ibus

# ------------------------------------------------------

%changelog
* Fri Apr 11 2025 tomcat <> 1.5.32-1.np9
- 1.5.32

* Sat Nov 09 2024 tomcat <> 1.5.31-1.np9
- 1.5.31 

* Fri May 03 2024 tomcat <> 1.5.30-1.np9
- 1.5.30
- fix %%post and %%postun in ibus-gtk3

* Fri Nov 17 2023 tomcat <> 1.5.29-1.np9
- 1.5.29
- add BR:%%{_lib}dbusmenu-glib-devel in ibus-ui-gtk3
- add BR:%%{_lib}dbusmenu-gtk3-devel in ibus-ui-gtk3
- add R:%%{_lib}dbusmenu-gtk3_4 in ibus-ui-gtk3

* Mon Apr 24 2023 tomcat <> 1.5.28-1.2.np9
- rebuild

* Sun Feb 26 2023 tomcat <> 1.5.28-1.1.np9
- build for Mageia 9
- sync official package
    * Source1 change file name from ibus.macros to macros.ibus
    * Source1 change install path from '/etc/rpm/macros.d' to '/usr/lib/rpm/macros.d'
